# Enumerated types tutorial

This screen capture (IDA 3.66) shows how IDA handles high level structures. This tutorial shows you how to obtain this result.

![](/files/uJZzTXALdImLk8P5f6Ze)

You can use IDA to interactively define and manipulate enumerated types in the disassembly. Consider this simple sample C program:

```
enum color_t {
    BLACK,          /* dark colors */
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    DARKGRAY,           /* light colors */
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE
};

enum day_t { MONDAY, TUESDAY, WEDNESDAY, THUSDAY, FRIDAY, SATURDAY, SUNDAY };

enum bool_t { FALSE, TRUE };

int is_suitable_color(day_t day,color_t color) {
  if ( (day == SUNDAY || day == SATURDAY) && color == RED ) return TRUE;
  if ( color == BLACK || color == BLUE ) return TRUE;
  return FALSE;
}
```

In order to use meaningful names instead of numbers, we open the enums window and press insert to define a new enumerated type.

![](/files/spM9HosmIR6pduAkvitZ)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hex-rays.com/9.0sp1/archive/enum-tutorial.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
